package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.ShopCategoryService;
import com.gxwebsoft.shop.entity.ShopCategory;
import com.gxwebsoft.shop.param.ShopCategoryParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.v3.oas.annotations.tags.Tag;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商品分类控制器
 *
 * @author 科技小王子
 * @since 2025-04-24 20:52:13
 */
@Tag(name = "商品分类管理")
@RestController
@RequestMapping("/api/shop/shop-category")
public class ShopCategoryController extends BaseController {
    @Resource
    private ShopCategoryService shopCategoryService;

    @Operation(summary = "分页查询商品分类")
    @GetMapping("/page")
    public ApiResult<PageResult<ShopCategory>> page(ShopCategoryParam param) {
        // 使用关联查询
        return success(shopCategoryService.pageRel(param));
    }

    @Operation(summary = "查询全部商品分类")
    @GetMapping()
    public ApiResult<List<ShopCategory>> list(ShopCategoryParam param) {
        // 使用关联查询
        return success(shopCategoryService.listRel(param));
    }

    @Operation(summary = "根据id查询商品分类")
    @GetMapping("/{id}")
    public ApiResult<ShopCategory> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(shopCategoryService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:shopCategory:save')")
    @OperationLog
    @Operation(summary = "添加商品分类")
    @PostMapping()
    public ApiResult<?> save(@RequestBody ShopCategory shopCategory) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
         shopCategory.setUserId(loginUser.getUserId());
        }
        if (shopCategoryService.save(shopCategory)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:shopCategory:update')")
    @OperationLog
    @Operation(summary = "修改商品分类")
    @PutMapping()
    public ApiResult<?> update(@RequestBody ShopCategory shopCategory) {
        if (shopCategoryService.updateById(shopCategory)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:shopCategory:remove')")
    @OperationLog
    @Operation(summary = "删除商品分类")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (shopCategoryService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:shopCategory:save')")
    @OperationLog
    @Operation(summary = "批量添加商品分类")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<ShopCategory> list) {
        if (shopCategoryService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:shopCategory:update')")
    @OperationLog
    @Operation(summary = "批量修改商品分类")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<ShopCategory> batchParam) {
        if (batchParam.update(shopCategoryService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:shopCategory:remove')")
    @OperationLog
    @Operation(summary = "批量删除商品分类")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (shopCategoryService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
